## seabios 1.14.0

=== Makefile ===
# SeaBIOS build system
#
# Copyright (C) 2008-2012  Kevin O'Connor <kevin@koconnor.net>
#
# This file may be distributed under the terms of the GNU LGPLv3 license.

# Output directory
OUT=out/

# Common command definitions
export HOSTCC             := $(CC)
export CONFIG_SHELL       := sh
export KCONFIG_AUTOHEADER := autoconf.h
export KCONFIG_CONFIG     := $(CURDIR)/.config
export LC_ALL             := C
CROSS_PREFIX=
ifneq ($(CROSS_PREFIX),)
CC=$(CROSS_PREFIX)gcc
endif
AS=$(CROSS_PREFIX)as
LD=$(CROSS_PREFIX)ld
OBJCOPY=$(CROSS_PREFIX)objcopy
OBJDUMP=$(CROSS_PREFIX)objdump
STRIP=$(CROSS_PREFIX)strip
PYTHON=python
CPP=cpp
IASL:=iasl
LD32BIT_FLAG:=-melf_i386

# Source files
SRCBOTH=misc.c stacks.c output.c string.c block.c cdrom.c disk.c	\
    mouse.c kbd.c system.c serial.c sercon.c clock.c resume.c		\
    pnpbios.c vgahooks.c pcibios.c apm.c cp437.c hw/pci.c hw/timer.c	\
    hw/rtc.c hw/dma.c hw/pic.c hw/ps2port.c hw/serialio.c hw/usb.c	\
    hw/usb-uhci.c hw/usb-ohci.c hw/usb-ehci.c hw/usb-hid.c		\
    hw/usb-msc.c hw/usb-uas.c hw/blockcmd.c hw/floppy.c hw/ata.c	\
    hw/ramdisk.c hw/lsi-scsi.c hw/esp-scsi.c hw/megasas.c		\
    hw/mpt-scsi.c
SRC16=$(SRCBOTH)
SRC32FLAT=$(SRCBOTH) post.c e820map.c malloc.c romfile.c x86.c		\
    optionroms.c pmm.c font.c boot.c bootsplash.c jpeg.c bmp.c		\
    tcgbios.c sha1.c hw/pcidevice.c hw/ahci.c hw/pvscsi.c		\
    hw/usb-xhci.c hw/usb-hub.c hw/sdcard.c fw/coreboot.c		\
    fw/lzmadecode.c fw/multiboot.c fw/csm.c fw/biostables.c		\
    fw/paravirt.c fw/shadow.c fw/pciinit.c fw/smm.c fw/smp.c		\
    fw/mtrr.c fw/xen.c fw/acpi.c fw/mptable.c fw/pirtable.c		\
    fw/smbios.c fw/romfile_loader.c fw/dsdt_parser.c hw/virtio-ring.c	\
    hw/virtio-pci.c hw/virtio-mmio.c hw/virtio-blk.c hw/virtio-scsi.c	\
    hw/tpm_drivers.c hw/nvme.c
SRC32SEG=string.c output.c pcibios.c apm.c stacks.c hw/pci.c hw/serialio.c
DIRS=src src/hw src/fw vgasrc

# Default compiler flags
cc-option=$(shell if test -z "`$(1) $(2) -S -o /dev/null -xc /dev/null 2>&1`" \
    ; then echo "$(2)"; else echo "$(3)"; fi ;)

EXTRAVERSION=

CPPFLAGS = -P -MD -MT $@

COMMONCFLAGS := -I$(OUT) -Isrc -Os -MD -g \
    -Wall -Wno-strict-aliasing -Wold-style-definition \
    $(call cc-option,$(CC),-Wtype-limits,) \
    -m32 -march=i386 -mregparm=3 -mpreferred-stack-boundary=2 \
    -minline-all-stringops -fomit-frame-pointer \
    -freg-struct-return -ffreestanding -fno-delete-null-pointer-checks \
    -ffunction-sections -fdata-sections -fno-common -fno-merge-constants
COMMONCFLAGS += $(call cc-option,$(CC),-nopie,)
COMMONCFLAGS += $(call cc-option,$(CC),-fno-pie,)
COMMONCFLAGS += $(call cc-option,$(CC),-fno-stack-protector,)
COMMONCFLAGS += $(call cc-option,$(CC),-fno-stack-protector-all,)
COMMONCFLAGS += $(call cc-option,$(CC),-fstack-check=no,)
COMMONCFLAGS += $(call cc-option,$(CC),-Wno-address-of-packed-member,)
COMMONCFLAGS += $(call cc-option,$(CC),-fcf-protection=none,)
COMMA := ,

CFLAGS32FLAT := $(COMMONCFLAGS) -DMODE16=0 -DMODESEGMENT=0
CFLAGSSEG := $(COMMONCFLAGS) -DMODESEGMENT=1 -fno-defer-pop \
    $(call cc-option,$(CC),-fno-jump-tables,-DMANUAL_NO_JUMP_TABLE) \
    $(call cc-option,$(CC),-fno-tree-switch-conversion,)
CFLAGS32SEG := $(CFLAGSSEG) -DMODE16=0
CFLAGS16 := $(CFLAGSSEG) -DMODE16=1 \
    $(call cc-option,$(CC),-m16,-Wa$(COMMA)src/code16gcc.s) \
    $(call cc-option,$(CC),--param large-stack-frame=4,-fno-inline)

# Run with "make V=1" to see the actual compile commands
ifdef V
Q=
else
Q=@
MAKEFLAGS += --no-print-directory
endif

# Default targets
-include $(KCONFIG_CONFIG)

target-y :=
target-$(CONFIG_QEMU) += $(OUT)bios.bin
target-$(CONFIG_CSM) += $(OUT)Csm16.bin
target-$(CONFIG_COREBOOT) += $(OUT)bios.bin.elf
target-$(CONFIG_BUILD_VGABIOS) += $(OUT)vgabios.bin

all: $(target-y)

# Make definitions
.PHONY : all clean distclean FORCE
.DELETE_ON_ERROR:


################ Common build rules

# Verify the build environment works.
TESTGCC:=$(shell OUT="$(OUT)" CC="$(CC)" LD="$(LD)" IASL="$(IASL)" scripts/test-build.sh)
ifeq "$(TESTGCC)" "-1"
$(error "Please upgrade the build environment")
endif

ifeq "$(TESTGCC)" "0"
# Use -fwhole-program
CFLAGSWHOLE=-fwhole-program -DWHOLE_PROGRAM
endif

# Do a whole file compile by textually including all C code.
define whole-compile
@echo "  Compiling whole program $3"
$(Q)printf '$(foreach i,$2,#include "$i"\n)' > $3.tmp.c
$(Q)$(CC) -I. $1 $(CFLAGSWHOLE) -c $3.tmp.c -o $3
endef

%.noexec.o: %.o
	@echo "  Stripping $@"
	$(Q)$(STRIP) $< -o $<.strip.o
	$(Q)$(PYTHON) ./scripts/ldnoexec.py $<.strip.o $@

$(OUT)%.s: %.c
	@echo "  Compiling to assembler $@"
	$(Q)$(CC) $(CFLAGS16) -S -c $< -o $@

$(OUT)%.o: %.c $(OUT)autoconf.h
	@echo "  Compile checking $@"
	$(Q)$(CC) $(CFLAGS32FLAT) -c $< -o $@

$(OUT)%.lds: %.lds.S
	@echo "  Precompiling $@"
	$(Q)$(CPP) $(CPPFLAGS) -D__ASSEMBLY__ $< -o $@


################ Main BIOS build rules

$(OUT)asm-offsets.s: $(OUT)autoconf.h

$(OUT)asm-offsets.h: $(OUT)src/asm-offsets.s
	@echo "  Generating offset file $@"
	$(Q)./scripts/gen-offsets.sh $< $@

$(OUT)ccode16.o: $(OUT)autoconf.h $(patsubst %.c, $(OUT)src/%.o,$(SRC16)) ; $(call whole-compile, $(CFLAGS16), $(addprefix src/, $(SRC16)),$@)

$(OUT)code32seg.o: $(OUT)autoconf.h $(patsubst %.c, $(OUT)src/%.o,$(SRC32SEG)) ; $(call whole-compile, $(CFLAGS32SEG), $(addprefix src/, $(SRC32SEG)),$@)

$(OUT)ccode32flat.o: $(OUT)autoconf.h $(patsubst %.c, $(OUT)src/%.o,$(SRC32FLAT)) ; $(call whole-compile, $(CFLAGS32FLAT), $(addprefix src/, $(SRC32FLAT)),$@)

$(OUT)romlayout.o: src/romlayout.S $(OUT)autoconf.h $(OUT)asm-offsets.h
	@echo "  Compiling (16bit) $@"
	$(Q)$(CC) $(CFLAGS16) -c -D__ASSEMBLY__ $< -o $@

$(OUT)romlayout16.lds: $(OUT)ccode32flat.o $(OUT)code32seg.o $(OUT)ccode16.o $(OUT)romlayout.o src/version.c scripts/layoutrom.py scripts/buildversion.py
	@echo "  Building ld scripts"
	$(Q)$(PYTHON) ./scripts/buildversion.py -e "$(EXTRAVERSION)" -t "$(CC);$(AS);$(LD);$(OBJCOPY);$(OBJDUMP);$(STRIP)" $(OUT)autoversion.h
	$(Q)$(CC) $(CFLAGS32FLAT) -c src/version.c -o $(OUT)version.o
	$(Q)$(LD) $(LD32BIT_FLAG) -r $(OUT)ccode32flat.o $(OUT)version.o -o $(OUT)code32flat.o
	$(Q)$(LD) $(LD32BIT_FLAG) -r $(OUT)ccode16.o $(OUT)romlayout.o -o $(OUT)code16.o
	$(Q)$(OBJDUMP) -thr $(OUT)code32flat.o > $(OUT)code32flat.o.objdump
	$(Q)$(OBJDUMP) -thr $(OUT)code32seg.o > $(OUT)code32seg.o.objdump
	$(Q)$(OBJDUMP) -thr $(OUT)code16.o > $(OUT)code16.o.objdump
	$(Q)$(PYTHON) ./scripts/layoutrom.py $(OUT)code16.o.objdump $(OUT)code32seg.o.objdump $(OUT)code32flat.o.objdump $(OUT)$(KCONFIG_AUTOHEADER) $(OUT)romlayout16.lds $(OUT)romlayout32seg.lds $(OUT)romlayout32flat.lds

# These are actually built by scripts/layoutrom.py above, but by pulling them
# into an extra rule we prevent make -j from spawning layoutrom.py 4 times.
$(OUT)romlayout32seg.lds $(OUT)romlayout32flat.lds $(OUT)code32flat.o $(OUT)code16.o: $(OUT)romlayout16.lds

$(OUT)rom16.o: $(OUT)code16.o $(OUT)romlayout16.lds
	@echo "  Linking $@"
	$(Q)$(LD) -T $(OUT)romlayout16.lds $< -o $@

$(OUT)rom32seg.o: $(OUT)code32seg.o $(OUT)romlayout32seg.lds
	@echo "  Linking $@"
	$(Q)$(LD) -T $(OUT)romlayout32seg.lds $< -o $@

$(OUT)rom.o: $(OUT)rom16.noexec.o $(OUT)rom32seg.noexec.o $(OUT)code32flat.o $(OUT)romlayout32flat.lds
	@echo "  Linking $@"
	$(Q)$(LD) -N -T $(OUT)romlayout32flat.lds $(OUT)rom16.noexec.o $(OUT)rom32seg.noexec.o $(OUT)code32flat.o -o $@

$(OUT)bios.bin.prep: $(OUT)rom.o scripts/checkrom.py
	@echo "  Prepping $@"
	$(Q)rm -f $(OUT)bios.bin $(OUT)Csm16.bin $(OUT)bios.bin.elf
	$(Q)$(OBJDUMP) -thr $< > $<.objdump
	$(Q)$(OBJCOPY) -O binary $< $(OUT)bios.bin.raw
	$(Q)$(PYTHON) ./scripts/checkrom.py $<.objdump $(CONFIG_ROM_SIZE) $(OUT)bios.bin.raw $(OUT)bios.bin.prep

$(OUT)bios.bin: $(OUT)bios.bin.prep
	@echo "  Creating $@"
	$(Q)cp $< $@

$(OUT)Csm16.bin: $(OUT)bios.bin.prep
	@echo "  Creating $@"
	$(Q)cp $< $@

$(OUT)bios.bin.elf: $(OUT)rom.o $(OUT)bios.bin.prep
	@echo "  Creating $@"
	$(Q)$(STRIP) -R .comment $< -o $(OUT)bios.bin.elf


################ VGA build rules

# VGA src files
SRCVGA=src/output.c src/string.c src/hw/pci.c src/hw/serialio.c \
    vgasrc/vgainit.c vgasrc/vgabios.c vgasrc/vgafb.c vgasrc/swcursor.c \
    vgasrc/vgafonts.c vgasrc/vbe.c \
    vgasrc/stdvga.c vgasrc/stdvgamodes.c vgasrc/stdvgaio.c \
    vgasrc/clext.c vgasrc/svgamodes.c vgasrc/atiext.c vgasrc/bochsvga.c vgasrc/geodevga.c \
    src/fw/coreboot.c vgasrc/cbvga.c vgasrc/bochsdisplay.c vgasrc/ramfb.c

ifeq "$(CONFIG_VGA_FIXUP_ASM)" "y"
$(OUT)vgaccode16.raw.s: $(OUT)autoconf.h $(patsubst %.c, $(OUT)%.o,$(SRCVGA)) ; $(call whole-compile, $(filter-out -fomit-frame-pointer,$(CFLAGS16)) -fno-omit-frame-pointer -S -Isrc, $(SRCVGA),$@)

$(OUT)vgaccode16.o: $(OUT)vgaccode16.raw.s scripts/vgafixup.py
	@echo "  Fixup VGA rom assembler"
	$(Q)$(PYTHON) ./scripts/vgafixup.py $< $(OUT)vgaccode16.s
	$(Q)$(AS) --32 src/code16gcc.s $(OUT)vgaccode16.s -o $@
else
$(OUT)vgaccode16.o: $(OUT)autoconf.h $(patsubst %.c, $(OUT)%.o,$(SRCVGA)) ; $(call whole-compile, $(CFLAGS16) -Isrc, $(SRCVGA),$@)
endif

$(OUT)vgaentry.o: vgasrc/vgaentry.S $(OUT)autoconf.h $(OUT)asm-offsets.h
	@echo "  Compiling (16bit) $@"
	$(Q)$(CC) $(CFLAGS16) -c -D__ASSEMBLY__ $< -o $@

$(OUT)vgarom.o: $(OUT)vgaccode16.o $(OUT)vgaentry.o $(OUT)vgasrc/vgalayout.lds vgasrc/vgaversion.c scripts/buildversion.py
	@echo "  Linking $@"
	$(Q)$(PYTHON) ./scripts/buildversion.py -e "$(EXTRAVERSION)" -t "$(CC);$(AS);$(LD);$(OBJCOPY);$(OBJDUMP);$(STRIP)" $(OUT)autovgaversion.h
	$(Q)$(CC) $(CFLAGS16) -c vgasrc/vgaversion.c -o $(OUT)vgaversion.o
	$(Q)$(LD) --gc-sections -T $(OUT)vgasrc/vgalayout.lds $(OUT)vgaccode16.o $(OUT)vgaentry.o $(OUT)vgaversion.o -o $@

$(OUT)vgabios.bin.raw: $(OUT)vgarom.o
	@echo "  Extracting binary $@"
	$(Q)$(OBJCOPY) -O binary $< $@

$(OUT)vgabios.bin: $(OUT)vgabios.bin.raw scripts/buildrom.py
	@echo "  Finalizing rom $@"
	$(Q)$(PYTHON) ./scripts/buildrom.py $< $@


################ DSDT build rules

iasl-option=$(shell if test -z "`$(1) $(2) 2>&1 > /dev/null`" \
    ; then echo "$(2)"; else echo "$(3)"; fi ;)

%.hex: %.dsl ./scripts/acpi_extract_preprocess.py ./scripts/acpi_extract.py
	@echo "  Compiling IASL $@"
	$(Q)$(CPP) $(CPPFLAGS) $< -o $(OUT)$*.dsl.i.orig
	$(Q)$(PYTHON) ./scripts/acpi_extract_preprocess.py $(OUT)$*.dsl.i.orig > $(OUT)$*.dsl.i
	$(Q)$(IASL) $(call iasl-option,$(IASL),-Pn,) -vs -l -tc -p $(OUT)$* $(OUT)$*.dsl.i
	$(Q)$(PYTHON) ./scripts/acpi_extract.py $(OUT)$*.lst > $(OUT)$*.off
	$(Q)cat $(OUT)$*.off > $@

iasl: src/fw/acpi-dsdt.hex src/fw/ssdt-proc.hex src/fw/ssdt-pcihp.hex src/fw/ssdt-misc.hex

################ Kconfig rules

define do-kconfig
$(Q)mkdir -p $(OUT)/scripts/kconfig/lxdialog
$(Q)mkdir -p $(OUT)/include/config
$(Q)mkdir -p $(addprefix $(OUT), $(DIRS))
$(Q)$(MAKE) -C $(OUT) -f $(CURDIR)/scripts/kconfig/Makefile srctree=$(CURDIR) src=scripts/kconfig obj=scripts/kconfig Q=$(Q) Kconfig=$(CURDIR)/src/Kconfig $1
endef

$(OUT)autoconf.h : $(KCONFIG_CONFIG) ; $(call do-kconfig, silentoldconfig)
$(KCONFIG_CONFIG): src/Kconfig vgasrc/Kconfig ; $(call do-kconfig, olddefconfig)
%onfig: ; $(call do-kconfig, $@)
help: ; $(call do-kconfig, $@)


################ Generic rules

clean:
	$(Q)rm -rf $(OUT)

distclean: clean
	$(Q)rm -f .config .config.old

-include $(OUT)*.d $(patsubst %,$(OUT)%/*.d,$(DIRS))

=== debian/changelog ===
seabios (1.14.0-2) unstable; urgency=medium

  * install vgabios-ramfb.bin, not romfb
    (Closes: #972482, #976806, LP: #1899546)
  * mention closing of #964663 by 1.14.0
  * d/control: update Standards-Version to 4.5.1 (no changes)

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 08 Dec 2020 14:52:59 +0300

seabios (1.14.0-1) unstable; urgency=medium

  [ Aurelien Jarno ]
  * Remove myself from maintainers

  [ Michael Tokarev ]
  * new upstream release (1.14.0) (Closes: #964663)
  * actually enable vgabios-bochs-display.bin, and also enable vgabios-romfb.bin
  * set more "=n" flags for stripped-down bios.bin
  * strip trailing spaces from d/changelog
  * switch from d/compat 9 to debhelper-compat 12
  * bump Standards-Version to 4.5.0, no changes
  * reorganize d/rules so that all */*-indep/*-arch targets are available
  * reorganize d/rules to run all variants sequentially but each variant
    in parallel, so that less clutter will be seen on output
  * d/control: use https for homepage
  * d/control: Rules-Requires-Root: no

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 10 Aug 2020 20:53:12 +0300

=== debian/control ===
Source: seabios
Section: misc
Priority: optional
Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
Uploaders: Riku Voipio <riku.voipio@iki.fi>,
	Michael Tokarev <mjt@tls.msk.ru>
Build-Depends: debhelper-compat (= 12), python3, acpica-tools | iasl
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/qemu-team/seabios
Vcs-Git: https://salsa.debian.org/qemu-team/seabios.git
Homepage: https://www.seabios.org

Package: seabios
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: qemu-system (<< 0.14.0), qemu-kvm (<< 0.14.0)
Description: Legacy BIOS implementation
 SeaBIOS is a legacy BIOS implementation, aimed at supporting not only
 emulated hosts such as QEMU, but also real hardware.
 .
 Note, however, that SeaBIOS does not handle early initialization of core
 chipsets, so don't even think of flashing it to your board (look at
 Coreboot for that).

=== debian/rules ===
#!/usr/bin/make -f

# in order to keep output non-intermixed together, disable parallel building
# of different targets in this d/rules but allow running parallel submakes
.NOTPARALLEL:

MAKEVARS = PYTHON="python3 -B" EXTRAVERSION="-${DEB_VERSION_RELEASE}"

dpkg_late_eval ?= $(or $(value DPKG_CACHE_$(1)),$(eval DPKG_CACHE_$(1) := $(shell $(2)))$(value DPKG_CACHE_$(1)))
DEB_VERSION = $(call dpkg_late_eval,DEB_VERSION,dpkg-parsechangelog -SVersion)
# everything after last minus sign
DEB_VERSION_RELEASE = $(call dpkg_late_eval,DEB_VERSION_RELEASE,echo '$(DEB_VERSION)' | sed -e 's/^.*-//')

VGABIOSES = ati bochs-display cirrus stdvga virtio vmware qxl isavga ramfb
VGABIOS_TARGETS = $(addprefix build/vgabios-, $(addsuffix .bin, $(VGABIOSES)))
BIOS_TARGETS = build/bios.bin build/bios-256k.bin ${VGABIOS_TARGETS}
BUILD_TARGETS = $(BIOS_TARGETS) build/optionrom-stamp

build build-indep: $(BUILD_TARGETS)

# common rule to build any bios.
# $1: build target: bios or vgabios, builds $(OUT)/$1
# $2: config options to put into .config without CONFIG_ prefix
# $@: where to put output; build dir will be $(basename $@)
define build-bios
@echo "\\n=== Building ${@F} ===\\n"
set -e; \
if [ ! -e $(basename $@)/.config.old ]; then \
 rm -rf $(basename $@); mkdir -p $(basename $@); \
 for x in $2; do \
  case $$x in \
   (*=n) echo "# CONFIG_$${x%=*} is not set";; \
   (*) echo CONFIG_$$x;; \
  esac; \
 done > $(basename $@)/.config; \
 $(MAKE) ${MAKEVARS} KCONFIG_CONFIG=$(CURDIR)/$(basename $@)/.config OUT=$(basename $@)/ oldnoconfig; \
fi
+$(MAKE) ${MAKEVARS} KCONFIG_CONFIG=$(CURDIR)/$(basename $@)/.config OUT=$(basename $@)/ $(basename $@)/$1.bin
rm -f $@
ln $(basename $@)/$1.bin $@
endef

build/bios.bin:
# A stripped-down version of bios, to fit in 128Kb, for qemu <= 1.7
	$(call build-bios,bios,QEMU=y ROM_SIZE=128 PVSCSI=n ATA_DMA=n BOOTSPLASH=n XEN=n USB_OHCI=n USB_XHCI=n USB_UAS=n SDCARD=n TCGBIOS=n MPT_SCSI=n ESP_SCSI=n MEGASAS=n NVME=n USE_SMM=n VGAHOOKS=n HOST_BIOS_GEOMETRY=n ACPI_PARSE=n)
build/bios-256k.bin:
	$(call build-bios,bios,QEMU=y ROM_SIZE=256)

${BIOS_TARGETS}: build/env-stamp
build/env-stamp:
# upstream checks for .git and .version in scripts/buildversion.py
# .version comes in upstream tarball, and .git should not be there
	[ ! -d .git ] || { echo "Directory .git exists, aborting" >&2; exit 1; }
	[ -f .version ] || echo ${DEB_VERSION} | sed 's/-.*//' > .version
	mkdir -p build
# regenerate shipped .hex files (iasl-compiled .dsl)
	rm -f src/fw/*.hex
# make iasl unnecessarily generates .config
	${MAKE} ${MAKEVARS} OUT=build/ KCONFIG_CONFIG=$(CURDIR)/build/.fakeconfig iasl
	touch $@

build/vgabios-ati.bin:
	$(call build-bios,vgabios,BUILD_VGABIOS=y VGA_ATI=y VGA_PCI=y)
build/vgabios-bochs-display.bin:
	$(call build-bios,vgabios,BUILD_VGABIOS=y DISPLAY_BOCHS=y VGA_PCI=y)
build/vgabios-cirrus.bin:
	$(call build-bios,vgabios,BUILD_VGABIOS=y VGA_CIRRUS=y VGA_PCI=y)
build/vgabios-stdvga.bin:
	$(call build-bios,vgabios,BUILD_VGABIOS=y VGA_BOCHS=y VGA_PCI=y)
build/vgabios-virtio.bin:
	$(call build-bios,vgabios,BUILD_VGABIOS=y VGA_BOCHS=y VGA_PCI=y \
		OVERRIDE_PCI_ID=y VGA_VID=0x1af4 VGA_DID=0x1050)
build/vgabios-vmware.bin:
	$(call build-bios,vgabios,BUILD_VGABIOS=y VGA_BOCHS=y VGA_PCI=y \
		OVERRIDE_PCI_ID=y VGA_VID=0x15ad VGA_DID=0x0405)
build/vgabios-qxl.bin:
	$(call build-bios,vgabios,BUILD_VGABIOS=y VGA_BOCHS=y VGA_PCI=y \
		OVERRIDE_PCI_ID=y VGA_VID=0x1b36 VGA_DID=0x0100)
build/vgabios-isavga.bin:
	$(call build-bios,vgabios,BUILD_VGABIOS=y VGA_BOCHS=y VGA_PCI=n)
build/vgabios-ramfb.bin:
	$(call build-bios,vgabios,BUILD_VGABIOS=y VGA_RAMFB=y VGA_PCI=n)

build/optionrom-stamp:
	$(MAKE) -C debian/optionrom/
	chmod -x debian/optionrom/*.bin
	ln -s kvmvapic.bin debian/optionrom/vapic.bin
	mkdir -p $(dir $@) && touch $@

clean:
	dh_testdir
	rm -rf build/
	rm -f src/fw/*.hex
	$(MAKE) -C debian/optionrom/ clean
	dh_clean

install install-indep: build-indep
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	dh_install

binary binary-indep: install-indep
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installman
	dh_installchangelogs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

build-arch install-arch binary-arch:
# nothing

.PHONY: build build-indep build-arch clean binary binary-indep binary-arch install install-indep install-arch

## seabios 1.15.0

=== debian/changelog ===
seabios (1.15.0-1) unstable; urgency=medium

  * New upstream release:
   * Improved support for USB devices with multiple interfaces.
   * Support for USB XHCI devices using direct MMIO access (instead of PCI).
   * NVMe improvements.
   * Increased "f-segment" RAM allocations for BIOS tables.
   * Several bug fixes and code cleanups.
  * Update Standards-Version to 4.6.0 (no changes)
  * Stop breaking pre-historic (0.14) qemu
  * Stop building qemu optionrom which is built on qemy itself
    since qemu 3.1 (buster)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 05 Dec 2021 12:58:22 +0300

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Riku Voipio <riku.voipio@iki.fi>,
 	Michael Tokarev <mjt@tls.msk.ru>
 Build-Depends: debhelper-compat (= 12), python3, acpica-tools | iasl
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/qemu-team/seabios
 Vcs-Git: https://salsa.debian.org/qemu-team/seabios.git
@@ -15,7 +15,6 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
-Breaks: qemu-system (<< 0.14.0), qemu-kvm (<< 0.14.0)
 Description: Legacy BIOS implementation
  SeaBIOS is a legacy BIOS implementation, aimed at supporting not only
  emulated hosts such as QEMU, but also real hardware.

=== debian/rules ===
--- 
+++ 
@@ -13,8 +13,8 @@
 
 VGABIOSES = ati bochs-display cirrus stdvga virtio vmware qxl isavga ramfb
 VGABIOS_TARGETS = $(addprefix build/vgabios-, $(addsuffix .bin, $(VGABIOSES)))
-BIOS_TARGETS = build/bios.bin build/bios-256k.bin ${VGABIOS_TARGETS}
-BUILD_TARGETS = $(BIOS_TARGETS) build/optionrom-stamp
+BIOS_TARGETS = build/bios.bin build/bios-256k.bin build/bios-microvm.bin ${VGABIOS_TARGETS}
+BUILD_TARGETS = $(BIOS_TARGETS)
 
 build build-indep: $(BUILD_TARGETS)
 
@@ -27,12 +27,7 @@
 set -e; \
 if [ ! -e $(basename $@)/.config.old ]; then \
  rm -rf $(basename $@); mkdir -p $(basename $@); \
- for x in $2; do \
-  case $$x in \
-   (*=n) echo "# CONFIG_$${x%=*} is not set";; \
-   (*) echo CONFIG_$$x;; \
-  esac; \
- done > $(basename $@)/.config; \
+ for x in $2; do echo CONFIG_$$x; done > $(basename $@)/.config; \
  $(MAKE) ${MAKEVARS} KCONFIG_CONFIG=$(CURDIR)/$(basename $@)/.config OUT=$(basename $@)/ oldnoconfig; \
 fi
 +$(MAKE) ${MAKEVARS} KCONFIG_CONFIG=$(CURDIR)/$(basename $@)/.config OUT=$(basename $@)/ $(basename $@)/$1.bin
@@ -45,6 +40,9 @@
 	$(call build-bios,bios,QEMU=y ROM_SIZE=128 PVSCSI=n ATA_DMA=n BOOTSPLASH=n XEN=n USB_OHCI=n USB_XHCI=n USB_UAS=n SDCARD=n TCGBIOS=n MPT_SCSI=n ESP_SCSI=n MEGASAS=n NVME=n USE_SMM=n VGAHOOKS=n HOST_BIOS_GEOMETRY=n ACPI_PARSE=n)
 build/bios-256k.bin:
 	$(call build-bios,bios,QEMU=y ROM_SIZE=256)
+build/bios-microvm.bin:
+	$(call build-bios,bios,QEMU=y ROM_SIZE=256 XEN=n BOOTSPLASH=n ATA=n AHCI=n SDCARD=n PVSCSI=n ESP_SCSI=n LSI_SCSI=n MEGASAS=n MPT_SCSI=n FLOPPY=n NVME=n PS2PORT=n USB=n LPT=n RTC_TIMER=n USE_SMM=n PMTIMER=n TCGBIOS=n HARDWARE_IRQ=n ACPI_PARSE=y)
+
 
 ${BIOS_TARGETS}: build/env-stamp
 build/env-stamp:
@@ -81,17 +79,10 @@
 build/vgabios-ramfb.bin:
 	$(call build-bios,vgabios,BUILD_VGABIOS=y VGA_RAMFB=y VGA_PCI=n)
 
-build/optionrom-stamp:
-	$(MAKE) -C debian/optionrom/
-	chmod -x debian/optionrom/*.bin
-	ln -s kvmvapic.bin debian/optionrom/vapic.bin
-	mkdir -p $(dir $@) && touch $@
-
 clean:
 	dh_testdir
 	rm -rf build/
 	rm -f src/fw/*.hex
-	$(MAKE) -C debian/optionrom/ clean
 	dh_clean
 
 install install-indep: build-indep

## seabios 1.16.0

=== debian/changelog ===
seabios (1.16.0-4) unstable; urgency=medium

  * set bios-microvm.bin bios size to be 128k not 256k.
    Upstream qemu uses 128k, but for some reason I set it to 256k when
    adding it to the debian package.  This change breaks migration between
    qemu running with old and new bios package but only for those VMs which
    are using this particular bios variant. In debian it is most likely the
    still-experimental qemu-system-x86_64-microvm binary.  It is better to
    fix this sooner instead of waiting before many VMs with this bios will
    emerge.

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 01 May 2022 14:59:52 +0300

seabios (1.16.0-3) unstable; urgency=medium

  * fix a FTBFS bug in previous upload (too much cleanup is no good)

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 01 May 2022 13:50:36 +0300

seabios (1.16.0-2) unstable; urgency=medium

  * d/control: switch to dh-compat=13 and use python3:any not python3
  * d/rules: set EXTRAVERSION to have -debian suffix
    (and cache it in build/env)
  * d/rules: collapse rules for vgabios-*.bin and bios*.bin into
    pattern rules with configs stored in make variables
  * d/rules: other small tweaks
  * d/changelog: wrap a long line in previous entry

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 01 May 2022 11:32:57 +0300

seabios (1.16.0-1) unstable; urgency=medium

  * new upstream release
  * d/links: remove /usr/share/seabios/optionrom/ old-compat symlinks
    which become dangling (Closes: #1003111)
  * d/control: remove Riku Voipio from Uploaders. Thank you Riko!
    (Closes: #1001567)
  * d/watch: add missing slash so it actually work
  * d/gbp.conf: specify upstream-vcs-tag format and filter generated
    src/fw/*.hex
  * nogitversion.patch: stop treating existance of .git/ as alternative version
  * d/rules: stop aborting if .git/ exists
  * d/rules: stop runnig dh_links and dh_installdirs
  * d/rules: reduce the clean target to one dh_clean invocation
  * d/rules: stop running dh_strip, we do not ship regular ELF binaries
  * d/rules: run dh_strip_nondeterminism
  * d/rules: move d/install into d/rules's dh_install line:
    we install just 2 patterns, can do that directly in d/rules

 -- Michael Tokarev <mjt@tls.msk.ru>  Sun, 01 May 2022 02:23:45 +0300

=== debian/rules ===
#!/usr/bin/make -f

# in order to keep output non-intermixed together, disable parallel building
# of different targets in this d/rules but allow running parallel submakes
.NOTPARALLEL:

MAKEVARS = PYTHON="python3 -B"

VGABIOSES = ati bochs-display cirrus stdvga virtio vmware qxl isavga ramfb
VGABIOS_TARGETS = $(addprefix build/vgabios-, $(addsuffix .bin, $(VGABIOSES)))
BIOS_TARGETS = build/bios.bin build/bios-256k.bin build/bios-microvm.bin ${VGABIOS_TARGETS}
BUILD_TARGETS = $(BIOS_TARGETS)

build build-indep: $(BUILD_TARGETS)

# common rule to build any bios.
# $1: build target: bios or vgabios, builds $(OUT)/$1
# $2: config options to put into .config without CONFIG_ prefix
# $@: where to put output; build dir will be $(basename $@)
define build-bios
@echo "\\n=== Building ${@F} ===\\n"
set -e; \
if [ ! -e $(basename $@)/.config.old ]; then \
 rm -rf $(basename $@); mkdir -p $(basename $@); \
 for x in $2; do echo CONFIG_$$x; done > $(basename $@)/.config; \
 $(MAKE) ${MAKEVARS} KCONFIG_CONFIG=${CURDIR}/$(basename $@)/.config OUT=$(basename $@)/ oldnoconfig; \
fi
+$(MAKE) ${MAKEVARS} $$(cat build/env) KCONFIG_CONFIG=${CURDIR}/$(basename $@)/.config OUT=$(basename $@)/ $(basename $@)/$1.bin
rm -f $@
ln $(basename $@)/$1.bin $@
endef

${BIOS_TARGETS}: build/env
build/env:
	mkdir -p build
# regenerate shipped .hex files (iasl-compiled .dsl)
	rm -f src/fw/*.hex
# `make iasl' unnecessarily generates .config
	${MAKE} ${MAKEVARS} OUT=build/ KCONFIG_CONFIG=${CURDIR}/build/.fakeconfig iasl
	echo "EXTRAVERSION=-debian-$$(dpkg-parsechangelog -SVersion)" > $@

# A stripped-down version of bios, to fit in 128Kb, for qemu <= 1.7
bios-config = QEMU=y ROM_SIZE=128 PVSCSI=n ATA_DMA=n BOOTSPLASH=n XEN=n USB_OHCI=n USB_XHCI=n USB_UAS=n SDCARD=n TCGBIOS=n MPT_SCSI=n ESP_SCSI=n MEGASAS=n NVME=n USE_SMM=n VGAHOOKS=n HOST_BIOS_GEOMETRY=n ACPI_PARSE=n
bios-256k-config = QEMU=y ROM_SIZE=256
bios-microvm-config = QEMU=y ROM_SIZE=128 XEN=n BOOTSPLASH=n ATA=n AHCI=n SDCARD=n PVSCSI=n ESP_SCSI=n LSI_SCSI=n MEGASAS=n MPT_SCSI=n FLOPPY=n FLASH_FLOPPY=n NVME=n PS2PORT=n USB=n LPT=n RTC_TIMER=n USE_SMM=n PMTIMER=n TCGBIOS=n HARDWARE_IRQ=n ACPI_PARSE=y

# % does not match empty string hence "bio" not "bios"
build/bio%.bin:
	@$(if ${bio$*-config},,$(error no config for bio$* is set))
	$(call build-bios,bios,${bio$*-config})

vgabios-ati-config    = VGA_ATI=y VGA_PCI=y
vgabios-cirrus-config = VGA_CIRRUS=y VGA_PCI=y
vgabios-stdvga-config = VGA_BOCHS=y VGA_PCI=y
vgabios-virtio-config = VGA_BOCHS=y VGA_PCI=y OVERRIDE_PCI_ID=y VGA_VID=0x1af4 VGA_DID=0x1050
vgabios-vmware-config = VGA_BOCHS=y VGA_PCI=y OVERRIDE_PCI_ID=y VGA_VID=0x15ad VGA_DID=0x0405
vgabios-qxl-config    = VGA_BOCHS=y VGA_PCI=y OVERRIDE_PCI_ID=y VGA_VID=0x1b36 VGA_DID=0x0100
vgabios-isavga-config = VGA_BOCHS=y VGA_PCI=n
vgabios-ramfb-config  = VGA_RAMFB=y VGA_PCI=n
vgabios-bochs-display-config = DISPLAY_BOCHS=y VGA_PCI=y

build/vgabios-%.bin:
	@$(if ${vgabios-$*-config},,$(error no config for vgabios-$* is set))
	$(call build-bios,vgabios,BUILD_VGABIOS=y ${vgabios-$*-config})

clean:
	dh_clean build/ src/fw/*.hex

install install-indep: build-indep
	dh_testdir
	dh_testroot
	dh_prep
	dh_install build/*.bin build/src/fw/*dsdt.aml usr/share/seabios/

binary binary-indep: install-indep
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installman
	dh_installchangelogs
	dh_strip_nondeterminism
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol
	dh_md5sums
	dh_builddeb

build-arch install-arch binary-arch:
# nothing

.PHONY: build build-indep build-arch clean binary binary-indep binary-arch install install-indep install-arch

## seabios 1.16.2

=== debian/changelog ===
seabios (1.16.2-1) unstable; urgency=medium

  * sync with upstream stable 1.16.2 release (rel-1.16.2 tag):
    this brings up to the exactly same state as our rel-1.16.1.patch
    did, and brings up 2 more fixes:
    - usb: fix wrong init of keyboard/mouse's if first interface
      is not boot protocol
    - xen: require Xen info structure at 0x1000 to detect Xen

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 11 Apr 2023 16:08:25 +0300

seabios (1.16.0-5) unstable; urgency=medium

  * d/rules: vgabios.bin compatibility symlink for qemu (Closes: #1024382)
  * update release to 1.16.1 (as a patch file since tarball is not published)

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 01 Dec 2022 17:06:24 +0300

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,8 @@
 Section: misc
 Priority: optional
 Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
-Uploaders: Riku Voipio <riku.voipio@iki.fi>,
-	Michael Tokarev <mjt@tls.msk.ru>
-Build-Depends: debhelper-compat (= 12), python3, acpica-tools | iasl
+Uploaders: Michael Tokarev <mjt@tls.msk.ru>
+Build-Depends: debhelper-compat (= 13), python3:any, acpica-tools | iasl
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/qemu-team/seabios

=== debian/rules ===
--- 
+++ 
@@ -71,6 +71,8 @@
 	dh_testroot
 	dh_prep
 	dh_install build/*.bin build/src/fw/*dsdt.aml usr/share/seabios/
+# compatibility symlink for qemu, #1024382
+	dh_link usr/share/seabios/vgabios-isavga.bin usr/share/seabios/vgabios.bin
 
 binary binary-indep: install-indep
 	dh_testdir

## seabios 1.16.3

=== debian/changelog ===
seabios (1.16.3-2) unstable; urgency=medium

  * d/rules: turn off LSI_SCSI and DEBUG_IO for 128k bios variant.
    these are probably the last bits which can be turned off before
    we will start breaking old versions of qemu.  upstream qemu
    turned off all pci devices for 128k bios variant, leaving only
    stuff needed for -M isapc, since it dropped <1.7 machines
    compatibility

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 30 Nov 2023 20:20:26 +0300

seabios (1.16.3-1) unstable; urgency=medium

  * new upstream release (rel-1.16.3)
    this brings up a few fixes, including `ahci: handle TFES irq correctly'
    which is needed for qemu 8.2+ with `D2H FIS when processing NCQ command'
    commit, esp-scsi fixes, and more.

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 28 Nov 2023 12:05:35 +0300

=== debian/rules ===
--- 
+++ 
@@ -40,7 +40,8 @@
 	echo "EXTRAVERSION=-debian-$$(dpkg-parsechangelog -SVersion)" > $@
 
 # A stripped-down version of bios, to fit in 128Kb, for qemu <= 1.7
-bios-config = QEMU=y ROM_SIZE=128 PVSCSI=n ATA_DMA=n BOOTSPLASH=n XEN=n USB_OHCI=n USB_XHCI=n USB_UAS=n SDCARD=n TCGBIOS=n MPT_SCSI=n ESP_SCSI=n MEGASAS=n NVME=n USE_SMM=n VGAHOOKS=n HOST_BIOS_GEOMETRY=n ACPI_PARSE=n
+bios-config = QEMU=y ROM_SIZE=128 PVSCSI=n ATA_DMA=n BOOTSPLASH=n XEN=n USB_OHCI=n USB_XHCI=n USB_UAS=n SDCARD=n TCGBIOS=n MPT_SCSI=n ESP_SCSI=n MEGASAS=n NVME=n USE_SMM=n VGAHOOKS=n HOST_BIOS_GEOMETRY=n ACPI_PARSE=n \
+  LSI_SCSI=n DEBUG_IO=n
 bios-256k-config = QEMU=y ROM_SIZE=256
 bios-microvm-config = QEMU=y ROM_SIZE=128 XEN=n BOOTSPLASH=n ATA=n AHCI=n SDCARD=n PVSCSI=n ESP_SCSI=n LSI_SCSI=n MEGASAS=n MPT_SCSI=n FLOPPY=n FLASH_FLOPPY=n NVME=n PS2PORT=n USB=n LPT=n RTC_TIMER=n USE_SMM=n PMTIMER=n TCGBIOS=n HARDWARE_IRQ=n ACPI_PARSE=y

## seabios 1.17.0

=== debian/changelog ===
seabios (1.17.0-1) unstable; urgency=medium

  * new upstream release:
   - Prefer PCI IO allocations above 4Gig on 64bit capable machines
   - Multiple simultaneous USB keyboard and mouse support
   - Legacy support for internally generated ACPI tables has been removed
   - SeaVGABIOS support for VBE get/set palette data
   - Several bug fixes and code cleanups
  * d/rules: stop messing with acpi tables
  * d/control: do not build-depend on acpica-tools/iasl anymore

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 09 Sep 2025 21:35:53 +0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian QEMU Team <pkg-qemu-devel@lists.alioth.debian.org>
 Uploaders: Michael Tokarev <mjt@tls.msk.ru>
-Build-Depends: debhelper-compat (= 13), python3:any, acpica-tools | iasl
+Build-Depends: debhelper-compat (= 13), python3:any
 Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/qemu-team/seabios

=== debian/rules ===
--- 
+++ 
@@ -33,10 +33,6 @@
 ${BIOS_TARGETS}: build/env
 build/env:
 	mkdir -p build
-# regenerate shipped .hex files (iasl-compiled .dsl)
-	rm -f src/fw/*.hex
-# `make iasl' unnecessarily generates .config
-	${MAKE} ${MAKEVARS} OUT=build/ KCONFIG_CONFIG=${CURDIR}/build/.fakeconfig iasl
 	echo "EXTRAVERSION=-debian-$$(dpkg-parsechangelog -SVersion)" > $@
 
 # A stripped-down version of bios, to fit in 128Kb, for qemu <= 1.7
@@ -65,13 +61,13 @@
 	$(call build-bios,vgabios,BUILD_VGABIOS=y ${vgabios-$*-config})
 
 clean:
-	dh_clean build/ src/fw/*.hex
+	dh_clean build/
 
 install install-indep: build-indep
 	dh_testdir
 	dh_testroot
 	dh_prep
-	dh_install build/*.bin build/src/fw/*dsdt.aml usr/share/seabios/
+	dh_install build/*.bin usr/share/seabios/
 # compatibility symlink for qemu, #1024382
 	dh_link usr/share/seabios/vgabios-isavga.bin usr/share/seabios/vgabios.bin

=== debian/watch ===
version=3
https://www.seabios.org/downloads/ seabios-(\d[^\s/]*)\.tar\.(?:xz|gz|bz2)
